package com.steerinfo.meterwork.meterworkmeasuringinstrument.controller;

import com.steerinfo.baseinfo.meterbaseunitdirect.model.MeterBaseUnitDirect;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkmeasuringinstrument.model.MeterWorkMeasuringInstrument;
import com.steerinfo.meterwork.meterworkmeasuringinstrument.service.IMeterWorkMeasuringInstrumentService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MeterWorkMeasuringInstrument RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-03-04 05:30
 * 类描述
 * 修订历史：
 * 日期：2022-03-04
 * 作者：generator
 * 参考：
 * 描述：MeterWorkMeasuringInstrument RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkmeasuringinstruments")
public class MeterWorkMeasuringInstrumentController extends BaseRESTfulController {

    @Autowired
    IMeterWorkMeasuringInstrumentService meterWorkMeasuringInstrumentService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeasuringinstrument:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkMeasuringInstrument> list = meterWorkMeasuringInstrumentService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeasuringinstrument:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkMeasuringInstrument> list = meterWorkMeasuringInstrumentService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeasuringinstrument:view")
    @PostMapping(value = "/like/")
    public RESTfulResult listLikePost(@RequestBody HashMap parmas){
        Integer pageNum = parmas.get("pageNum") == null ? 1 : Integer.parseInt(parmas.get("pageNum").toString());
        Integer pageSize =parmas.get("pageSize") == null ? 20 : Integer.parseInt(parmas.get("pageSize").toString());
        PageList<MeterWorkMeasuringInstrument> list = meterWorkMeasuringInstrumentService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkmeasuringinstrument:view")
    @GetMapping(value = "/likeDesc/")
    public RESTfulResult likeDesc(@RequestParam HashMap parmas){
        Integer pageNum = parmas.get("pageNum") == null ? 1 : Integer.parseInt(parmas.get("pageNum").toString());
        Integer pageSize =parmas.get("pageSize") == null ? 20 : Integer.parseInt(parmas.get("pageSize").toString());
        PageList<MeterWorkMeasuringInstrument> list = meterWorkMeasuringInstrumentService.likeDesc(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="创建", notes="根据MeterWorkMeasuringInstrument对象创建")
    @ApiImplicitParam(name = "meterWorkMeasuringInstrument", value = "详细实体meterWorkMeasuringInstrument", required = true, dataType = "MeterWorkMeasuringInstrument")
    //@RequiresPermissions("meterworkmeasuringinstrument:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterWorkMeasuringInstrument model){
        try{
            String msg = meterWorkMeasuringInstrumentService.checkandadd(model);
            if (msg != "" && !msg.equals("")) {
                return  failed(null,msg);
            }
        }catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkmeasuringinstrument:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkMeasuringInstrument meterWorkMeasuringInstrument = meterWorkMeasuringInstrumentService.getById(id);
        return success(meterWorkMeasuringInstrument);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkMeasuringInstrument信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkMeasuringInstrument", value = "详细实体meterWorkMeasuringInstrument", required = true, dataType = "MeterWorkMeasuringInstrument")
    })
    //@RequiresPermissions("meterworkmeasuringinstrument:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkMeasuringInstrument model){
        model.setId(id);
        MeterWorkMeasuringInstrument meterWorkMeasuringInstrument = meterWorkMeasuringInstrumentService.modify(model);
        return success(meterWorkMeasuringInstrument);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkmeasuringinstrument:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkMeasuringInstrumentService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "批量导入", notes = "根据MeterWorkMeasuringInstrument对象批量导入")
    @ApiImplicitParam(paramType = "path",  required = true, dataType = "List<MeterWorkMeasuringInstrument>")
    @Transactional
    @PostMapping(value = "/batchAddInfo")//String
    public RESTfulResult batchAddInfo(@RequestBody List<MeterWorkMeasuringInstrument> models) {
        try {
            RESTfulResult rm = meterWorkMeasuringInstrumentService.batchAddInfo(models);
            return rm;
        } catch (Exception ex) {
            ex.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
